Getting Started with MultiSplitButton Web Component
Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.
Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.
Quick start
- Install the package:
npm install smart-webcomponents
- Load the MultiSplitButton module (ES module script):
<script type="module" src="node_modules/smart-webcomponents/source/modules/smart.multisplitbutton.js"></script>
- Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):
<link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />
- Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host
div(you mount programmatically with appendTo):
Semantic element (id matches the selector in Smart()):
<smart-multi-split-button id="multisplitbutton"></smart-multi-split-button>
Host container (id matches appendTo on Smart.MultiSplitButton):
<div id="multisplitbuttonContainer"></div>
- Initialize after the module loads: define a const multisplitbuttonOptions object, then either bind with Smart('#multisplitbutton', ...) on the semantic tag or use new Smart.MultiSplitButton({ ...multisplitbuttonOptions, appendTo: '#multisplitbuttonContainer' }) on the host
div:
<script type="module"> import 'node_modules/smart-webcomponents/source/modules/smart.multisplitbutton.js'; const multisplitbuttonOptions = { disabled: true }; // Option A - semantic <smart-multi-split-button> with id="multisplitbutton" Smart('#multisplitbutton', class { get properties() { return multisplitbuttonOptions; } }); // Option B - host div id="multisplitbuttonContainer" // const multisplitbuttonInstance = new Smart.MultiSplitButton({ // ...multisplitbuttonOptions, // appendTo: '#multisplitbuttonContainer' // }); // Option C - constructor(selector, options), then append the returned element yourself // const myMultiSplitButton = new Smart.MultiSplitButton('#multisplitbutton', multisplitbuttonOptions); // document.body.appendChild(myMultiSplitButton); </script>
Uncomment Option B when you use the host
div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.MultiSplitButton('#multisplitbutton', multisplitbuttonOptions) with appendChild, and document.createElement('smart-multi-split-button') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components). - Serve the folder over HTTP (or use your bundler dev server) and open the page.
Runtime cookbook
Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.MultiSplitButton({ ...options, appendTo: '#...' }); new Smart.MultiSplitButton('#multisplitbutton', multisplitbuttonOptions) plus appendChild on the returned element; and document.createElement('smart-multi-split-button') then assigning options via .props or Object.assign on the element.
Constructor with a selector string and options, then append the returned element (for example const myMultiSplitButton = new Smart.MultiSplitButton('#multisplitbutton', multisplitbuttonOptions)):
const multisplitbuttonOptions = { disabled: true };
const myMultiSplitButton = new Smart.MultiSplitButton('#multisplitbutton', multisplitbuttonOptions);
document.body.appendChild(myMultiSplitButton);
Create with document.createElement('smart-multi-split-button'), assign properties (same as any custom element), then append:
const multisplitbuttonOptions = { disabled: true };
const multisplitbutton = document.createElement('smart-multi-split-button');
Object.assign(multisplitbutton, multisplitbuttonOptions);
document.body.appendChild(multisplitbutton);
Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):
import "../../source/modules/smart.multisplitbutton.js";
document.readyState === 'complete' ? init() : window.addEventListener('load', init);
function init() {
const multisplitbuttonOptions = { disabled: true };
const multisplitbutton = new Smart.MultiSplitButton({
...multisplitbuttonOptions,
appendTo: '#multisplitbuttonContainer'
});
}
Append to the DOM:
const container = document.getElementById('multisplitbutton-container');
container.appendChild(multisplitbutton);
Remove from the DOM:
multisplitbutton.remove();
Set a property:
multisplitbutton.disabled = true; multisplitbutton.theme = 'dark';
Get a property value:
const isDisabled = multisplitbutton.disabled; const currentTheme = multisplitbutton.theme;
Invoke a method:
multisplitbutton.refresh(); multisplitbutton.focus();
Add event listener:
multisplitbutton.addEventListener('change', (event) => {
console.log('change triggered:', event.detail.addedItems);
});
Remove event listener:
const handleMultiSplitButtonEvent = (event) => {
console.log('change triggered:', event.detail.addedItems);
};
multisplitbutton.addEventListener('change', handleMultiSplitButtonEvent);
multisplitbutton.removeEventListener('change', handleMultiSplitButtonEvent);
Accessibility
The MultiSplitButton component follows WAI-ARIA best practices:
- Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
- ARIA roles - Appropriate roles and labels are applied automatically
- Focus management - Visible focus indicators for keyboard users
- Screen readers - State changes are announced to assistive technology
- High contrast - Supports Windows High Contrast Mode and forced colors
For custom labeling, set aria-label or aria-labelledby attributes on the component.
Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular MultiSplitButton - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/multisplitbutton/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import MultiSplitButtonModule from smart-webcomponents-angular/multisplitbutton: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { MultiSplitButtonModule } from 'smart-webcomponents-angular/multisplitbutton';

4 Root component (standalone)

Add MultiSplitButtonModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { MultiSplitButtonComponent } from 'smart-webcomponents-angular/multisplitbutton';

import { MultiSplitButtonModule } from 'smart-webcomponents-angular/multisplitbutton';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ MultiSplitButtonModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('multisplitbutton', { read: MultiSplitButtonComponent, static: false }) multisplitbutton!: MultiSplitButtonComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-multi-split-button as needed:

 <smart-multi-split-button #multisplitbutton [buttonsDataSource]="['1', '2', '3']">
    <smart-list-item [value]="'Afghanistan'">Afghanistan</smart-list-item>
    <smart-list-item [selected]="true" [value]="'Albania'">Albania</smart-list-item>
    <smart-list-item [value]="'Algeria'">Algeria</smart-list-item>
    <smart-list-item [value]="'American Samoa'">American Samoa</smart-list-item>
    <smart-list-item [value]="'Andorra'">Andorra</smart-list-item>
    <smart-list-item [value]="'Angola'">Angola</smart-list-item>
    <smart-list-item [value]="'Anguilla'">Anguilla</smart-list-item>
    <smart-list-item [value]="'Antarctica'">Antarctica</smart-list-item>
    <smart-list-item [value]="'Antigua and Barbuda'">Antigua and Barbuda</smart-list-item>
    <smart-list-item [value]="'Argentina'">Argentina</smart-list-item>
    <smart-list-item [value]="'Armenia'">Armenia</smart-list-item>
    <smart-list-item [value]="'Aruba'">Aruba</smart-list-item>
    <smart-list-item [value]="'Australia'">Australia</smart-list-item>
    <smart-list-item [value]="'Austria'">Austria</smart-list-item>
    <smart-list-item [value]="'Azerbaijan'">Azerbaijan</smart-list-item>
    <smart-list-item [value]="'Bahamas'">Bahamas</smart-list-item>
    <smart-list-item [value]="'Bahrain'">Bahrain</smart-list-item>
    <smart-list-item [value]="'Bangladesh'">Bangladesh</smart-list-item>
    <smart-list-item [value]="'Barbados'">Barbados</smart-list-item>
    <smart-list-item [value]="'Belarus'">Belarus</smart-list-item>
    <smart-list-item [value]="'Belgium'">Belgium</smart-list-item>
    <smart-list-item [value]="'Belize'">Belize</smart-list-item>
    <smart-list-item [value]="'Benin'">Benin</smart-list-item>
    <smart-list-item [value]="'Bermuda'">Bermuda</smart-list-item>
    <smart-list-item [value]="'Bhutan'">Bhutan</smart-list-item>
    <smart-list-item [value]="'Bolivia'">Bolivia</smart-list-item>
    <smart-list-item [value]="'Bosnia and Herzegovina'">Bosnia and Herzegovina</smart-list-item>
    <smart-list-item [value]="'Botswana'">Botswana</smart-list-item>
    <smart-list-item [value]="'Bouvet Island'">Bouvet Island</smart-list-item>
    <smart-list-item [value]="'Brazil'">Brazil</smart-list-item>
    <smart-list-item [value]="'British Indian Ocean Territory'">British Indian Ocean Territory</smart-list-item>
    <smart-list-item [value]="'Brunei Darussalam'">Brunei Darussalam</smart-list-item>
    <smart-list-item [value]="'Bulgaria'">Bulgaria</smart-list-item>
    <smart-list-item [value]="'Burkina Faso'">Burkina Faso</smart-list-item>
    <smart-list-item [value]="'Burundi'">Burundi</smart-list-item>
    <smart-list-item [value]="'Cambodia'">Cambodia</smart-list-item>
    <smart-list-item [value]="'Cameroon'">Cameroon</smart-list-item>
    <smart-list-item [value]="'Canada'">Canada</smart-list-item>
    <smart-list-item [value]="'Cape Verde'">Cape Verde</smart-list-item>
    <smart-list-item [value]="'Cayman Islands'">Cayman Islands</smart-list-item>
    <smart-list-item [value]="'Central African Republic'">Central African Republic</smart-list-item>
    <smart-list-item [value]="'Chad'">Chad</smart-list-item>
    <smart-list-item [value]="'Chile'">Chile</smart-list-item>
    <smart-list-item [value]="'China'">China</smart-list-item>
    <smart-list-item [value]="'Christmas Island'">Christmas Island</smart-list-item>
    <smart-list-item [value]="'Cocos (Keeling) Islands'">Cocos Islands</smart-list-item>
    <smart-list-item [value]="'Colombia'">Colombia</smart-list-item>
    <smart-list-item [value]="'Comoros'">Comoros</smart-list-item>
    <smart-list-item [value]="'Congo'">Congo</smart-list-item>
    <smart-list-item [value]="'Congo, The Democratic Republic of The'">Congo</smart-list-item>
    <smart-list-item [value]="'Cook Islands'">Cook Islands</smart-list-item>
    <smart-list-item [value]="'Costa Rica'">Costa Rica</smart-list-item>
    <smart-list-item [value]="'Cote D\'ivoire'">Cote D'ivoire</smart-list-item>
    <smart-list-item [value]="'Croatia'">Croatia</smart-list-item>
    <smart-list-item [value]="'Cuba'">Cuba</smart-list-item>
    <smart-list-item [value]="'Cyprus'">Cyprus</smart-list-item>
    <smart-list-item [value]="'Czech Republic'">Czech Republic</smart-list-item>
    <smart-list-item [value]="'Denmark'">Denmark</smart-list-item>
    <smart-list-item [value]="'Djibouti'">Djibouti</smart-list-item>
    <smart-list-item [value]="'Dominica'">Dominica</smart-list-item>
    <smart-list-item [value]="'Dominican Republic'">Dominican Republic</smart-list-item>
    <smart-list-item [value]="'Ecuador'">Ecuador</smart-list-item>
    <smart-list-item [value]="'Egypt'">Egypt</smart-list-item>
    <smart-list-item [value]="'El Salvador'">El Salvador</smart-list-item>
    <smart-list-item [value]="'Equatorial Guinea'">Equatorial Guinea</smart-list-item>
    <smart-list-item [value]="'Eritrea'">Eritrea</smart-list-item>
    <smart-list-item [value]="'Estonia'">Estonia</smart-list-item>
    <smart-list-item [value]="'Ethiopia'">Ethiopia</smart-list-item>
    <smart-list-item [value]="'Falkland Islands (Malvinas)'">Falkland Islands</smart-list-item>
    <smart-list-item [value]="'Faroe Islands'">Faroe Islands</smart-list-item>
    <smart-list-item [value]="'Fiji'">Fiji</smart-list-item>
    <smart-list-item [value]="'Finland'">Finland</smart-list-item>
    <smart-list-item [value]="'France'">France</smart-list-item>
    <smart-list-item [value]="'French Guiana'">French Guiana</smart-list-item>
    <smart-list-item [value]="'French Polynesia'">French Polynesia</smart-list-item>
    <smart-list-item [value]="'French Southern Territories'">French Southern Territories</smart-list-item>
    <smart-list-item [value]="'Gabon'">Gabon</smart-list-item>
    <smart-list-item [value]="'Gambia'">Gambia</smart-list-item>
    <smart-list-item [value]="'Georgia'">Georgia</smart-list-item>
    <smart-list-item [value]="'Germany'">Germany</smart-list-item>
    <smart-list-item [value]="'Ghana'">Ghana</smart-list-item>
    <smart-list-item [value]="'Gibraltar'">Gibraltar</smart-list-item>
    <smart-list-item [value]="'Greece'">Greece</smart-list-item>
    <smart-list-item [value]="'Greenland'">Greenland</smart-list-item>
    <smart-list-item [value]="'Grenada'">Grenada</smart-list-item>
    <smart-list-item [value]="'Guadeloupe'">Guadeloupe</smart-list-item>
    <smart-list-item [value]="'Guam'">Guam</smart-list-item>
    <smart-list-item [value]="'Guatemala'">Guatemala</smart-list-item>
    <smart-list-item [value]="'Guinea'">Guinea</smart-list-item>
    <smart-list-item [value]="'Guinea-bissau'">Guinea-bissau</smart-list-item>
    <smart-list-item [value]="'Guyana'">Guyana</smart-list-item>
    <smart-list-item [value]="'Haiti'">Haiti</smart-list-item>
    <smart-list-item [value]="'Heard Island and Mcdonald Islands'">Heard Island and Mcdonald Islands</smart-list-item>
    <smart-list-item [value]="'Holy See (Vatican City State)'">Holy See</smart-list-item>
    <smart-list-item [value]="'Honduras'">Honduras</smart-list-item>
    <smart-list-item [value]="'Hong Kong'">Hong Kong</smart-list-item>
    <smart-list-item [value]="'Hungary'">Hungary</smart-list-item>
    <smart-list-item [value]="'Iceland'">Iceland</smart-list-item>
    <smart-list-item [value]="'India'">India</smart-list-item>
    <smart-list-item [value]="'Indonesia'">Indonesia</smart-list-item>
    <smart-list-item [value]="'Iran, Islamic Republic of'">Iran</smart-list-item>
    <smart-list-item [value]="'Iraq'">Iraq</smart-list-item>
    <smart-list-item [value]="'Ireland'">Ireland</smart-list-item>
    <smart-list-item [value]="'Israel'">Israel</smart-list-item>
    <smart-list-item [value]="'Italy'">Italy</smart-list-item>
    <smart-list-item [value]="'Jamaica'">Jamaica</smart-list-item>
    <smart-list-item [value]="'Japan'">Japan</smart-list-item>
    <smart-list-item [value]="'Jordan'">Jordan</smart-list-item>
    <smart-list-item [value]="'Kazakhstan'">Kazakhstan</smart-list-item>
    <smart-list-item [value]="'Kenya'">Kenya</smart-list-item>
    <smart-list-item [value]="'Kiribati'">Kiribati</smart-list-item>
    <smart-list-item [value]="'Korea, Democratic People\'s Republic of'">Korea</smart-list-item>
    <smart-list-item [value]="'Korea, Republic of'">Korea, Republic of</smart-list-item>
    <smart-list-item [value]="'Kuwait'">Kuwait</smart-list-item>
    <smart-list-item [value]="'Kyrgyzstan'">Kyrgyzstan</smart-list-item>
    <smart-list-item [value]="'Lao People\'s Democratic Republic'">Lao People's Democratic Republic</smart-list-item>
    <smart-list-item [value]="'Latvia'">Latvia</smart-list-item>
    <smart-list-item [value]="'Lebanon'">Lebanon</smart-list-item>
    <smart-list-item [value]="'Lesotho'">Lesotho</smart-list-item>
    <smart-list-item [value]="'Liberia'">Liberia</smart-list-item>
    <smart-list-item [value]="'Libyan Arab Jamahiriya'">Libyan Arab Jamahiriya</smart-list-item>
    <smart-list-item [value]="'Liechtenstein'">Liechtenstein</smart-list-item>
    <smart-list-item [value]="'Lithuania'">Lithuania</smart-list-item>
    <smart-list-item [value]="'Luxembourg'">Luxembourg</smart-list-item>
    <smart-list-item [value]="'Macao'">Macao</smart-list-item>
    <smart-list-item [value]="'Macedonia, The Former Yugoslav Republic of'">Macedonia</smart-list-item>
    <smart-list-item [value]="'Madagascar'">Madagascar</smart-list-item>
    <smart-list-item [value]="'Malawi'">Malawi</smart-list-item>
    <smart-list-item [value]="'Malaysia'">Malaysia</smart-list-item>
    <smart-list-item [value]="'Maldives'">Maldives</smart-list-item>
    <smart-list-item [value]="'Mali'">Mali</smart-list-item>
    <smart-list-item [value]="'Malta'">Malta</smart-list-item>
    <smart-list-item [value]="'Marshall Islands'">Marshall Islands</smart-list-item>
    <smart-list-item [value]="'Martinique'">Martinique</smart-list-item>
    <smart-list-item [value]="'Mauritania'">Mauritania</smart-list-item>
    <smart-list-item [value]="'Mauritius'">Mauritius</smart-list-item>
    <smart-list-item [value]="'Mayotte'">Mayotte</smart-list-item>
    <smart-list-item [value]="'Mexico'">Mexico</smart-list-item>
    <smart-list-item [value]="'Micronesia, Federated States of'">Micronesia</smart-list-item>
    <smart-list-item [value]="'Moldova, Republic of'">Moldova, Republic of</smart-list-item>
    <smart-list-item [value]="'Monaco'">Monaco</smart-list-item>
    <smart-list-item [value]="'Mongolia'">Mongolia</smart-list-item>
    <smart-list-item [value]="'Montserrat'">Montserrat</smart-list-item>
    <smart-list-item [value]="'Morocco'">Morocco</smart-list-item>
    <smart-list-item [value]="'Mozambique'">Mozambique</smart-list-item>
    <smart-list-item [value]="'Myanmar'">Myanmar</smart-list-item>
    <smart-list-item [value]="'Namibia'">Namibia</smart-list-item>
    <smart-list-item [value]="'Nauru'">Nauru</smart-list-item>
    <smart-list-item [value]="'Nepal'">Nepal</smart-list-item>
    <smart-list-item [value]="'Netherlands'">Netherlands</smart-list-item>
    <smart-list-item [value]="'Netherlands Antilles'">Netherlands Antilles</smart-list-item>
    <smart-list-item [value]="'New Caledonia'">New Caledonia</smart-list-item>
    <smart-list-item [value]="'New Zealand'">New Zealand</smart-list-item>
    <smart-list-item [value]="'Nicaragua'">Nicaragua</smart-list-item>
    <smart-list-item [value]="'Niger'">Niger</smart-list-item>
    <smart-list-item [value]="'Nigeria'">Nigeria</smart-list-item>
    <smart-list-item [value]="'Niue'">Niue</smart-list-item>
    <smart-list-item [value]="'Norfolk Island'">Norfolk Island</smart-list-item>
    <smart-list-item [value]="'Northern Mariana Islands'">Northern Mariana Islands</smart-list-item>
    <smart-list-item [value]="'Norway'">Norway</smart-list-item>
    <smart-list-item [value]="'Oman'">Oman</smart-list-item>
    <smart-list-item [value]="'Pakistan'">Pakistan</smart-list-item>
    <smart-list-item [value]="'Palau'">Palau</smart-list-item>
    <smart-list-item [value]="'Palestinian Territory, Occupied'">Palestinian Territory, Occupied</smart-list-item>
    <smart-list-item [value]="'Panama'">Panama</smart-list-item>
    <smart-list-item [value]="'Papua New Guinea'">Papua New Guinea</smart-list-item>
    <smart-list-item [value]="'Paraguay'">Paraguay</smart-list-item>
    <smart-list-item [value]="'Peru'">Peru</smart-list-item>
    <smart-list-item [value]="'Philippines'">Philippines</smart-list-item>
    <smart-list-item [value]="'Pitcairn'">Pitcairn</smart-list-item>
    <smart-list-item [value]="'Poland'">Poland</smart-list-item>
    <smart-list-item [value]="'Portugal'">Portugal</smart-list-item>
    <smart-list-item [value]="'Puerto Rico'">Puerto Rico</smart-list-item>
    <smart-list-item [value]="'Qatar'">Qatar</smart-list-item>
    <smart-list-item [value]="'Reunion'">Reunion</smart-list-item>
    <smart-list-item [value]="'Romania'">Romania</smart-list-item>
    <smart-list-item [value]="'Russian Federation'">Russian Federation</smart-list-item>
    <smart-list-item [value]="'Rwanda'">Rwanda</smart-list-item>
    <smart-list-item [value]="'Saint Helena'">Saint Helena</smart-list-item>
    <smart-list-item [value]="'Saint Kitts and Nevis'">Saint Kitts and Nevis</smart-list-item>
    <smart-list-item [value]="'Saint Lucia'">Saint Lucia</smart-list-item>
    <smart-list-item [value]="'Saint Pierre and Miquelon'">Saint Pierre and Miquelon</smart-list-item>
    <smart-list-item [value]="'Saint Vincent and The Grenadines'">Saint Vincent and The Grenadines</smart-list-item>
    <smart-list-item [value]="'Samoa'">Samoa</smart-list-item>
    <smart-list-item [value]="'San Marino'">San Marino</smart-list-item>
    <smart-list-item [value]="'Sao Tome and Principe'">Sao Tome and Principe</smart-list-item>
    <smart-list-item [value]="'Saudi Arabia'">Saudi Arabia</smart-list-item>
    <smart-list-item [value]="'Senegal'">Senegal</smart-list-item>
    <smart-list-item [value]="'Serbia and Montenegro'">Serbia and Montenegro</smart-list-item>
    <smart-list-item [value]="'Seychelles'">Seychelles</smart-list-item>
    <smart-list-item [value]="'Sierra Leone'">Sierra Leone</smart-list-item>
    <smart-list-item [value]="'Singapore'">Singapore</smart-list-item>
    <smart-list-item [value]="'Slovakia'">Slovakia</smart-list-item>
    <smart-list-item [value]="'Slovenia'">Slovenia</smart-list-item>
    <smart-list-item [value]="'Solomon Islands'">Solomon Islands</smart-list-item>
    <smart-list-item [value]="'Somalia'">Somalia</smart-list-item>
    <smart-list-item [value]="'South Africa'">South Africa</smart-list-item>
    <smart-list-item [value]="'South Georgia and The South Sandwich Islands'">South Georgia</smart-list-item>
    <smart-list-item [value]="'Spain'">Spain</smart-list-item>
    <smart-list-item [value]="'Sri Lanka'">Sri Lanka</smart-list-item>
    <smart-list-item [value]="'Sudan'">Sudan</smart-list-item>
    <smart-list-item [value]="'Suriname'">Suriname</smart-list-item>
    <smart-list-item [value]="'Svalbard and Jan Mayen'">Svalbard and Jan Mayen</smart-list-item>
    <smart-list-item [value]="'Swaziland'">Swaziland</smart-list-item>
    <smart-list-item [value]="'Sweden'">Sweden</smart-list-item>
    <smart-list-item [value]="'Switzerland'">Switzerland</smart-list-item>
    <smart-list-item [value]="'Syrian Arab Republic'">Syrian Arab Republic</smart-list-item>
    <smart-list-item [value]="'Taiwan, Province of China'">Taiwan, Province of China</smart-list-item>
    <smart-list-item [value]="'Tajikistan'">Tajikistan</smart-list-item>
    <smart-list-item [value]="'Tanzania, United Republic of'">Tanzania, United Republic of</smart-list-item>
    <smart-list-item [value]="'Thailand'">Thailand</smart-list-item>
    <smart-list-item [value]="'Timor-leste'">Timor-leste</smart-list-item>
    <smart-list-item [value]="'Togo'">Togo</smart-list-item>
    <smart-list-item [value]="'Tokelau'">Tokelau</smart-list-item>
    <smart-list-item [value]="'Tonga'">Tonga</smart-list-item>
    <smart-list-item [value]="'Trinidad and Tobago'">Trinidad and Tobago</smart-list-item>
    <smart-list-item [value]="'Tunisia'">Tunisia</smart-list-item>
    <smart-list-item [value]="'Turkey'">Turkey</smart-list-item>
    <smart-list-item [value]="'Turkmenistan'">Turkmenistan</smart-list-item>
    <smart-list-item [value]="'Turks and Caicos Islands'">Turks and Caicos Islands</smart-list-item>
    <smart-list-item [value]="'Tuvalu'">Tuvalu</smart-list-item>
    <smart-list-item [value]="'Uganda'">Uganda</smart-list-item>
    <smart-list-item [value]="'Ukraine'">Ukraine</smart-list-item>
    <smart-list-item [value]="'United Arab Emirates'">United Arab Emirates</smart-list-item>
    <smart-list-item [value]="'United Kingdom'">United Kingdom</smart-list-item>
    <smart-list-item [value]="'United States'">United States</smart-list-item>
    <smart-list-item [value]="'United States Minor Outlying Islands'">United States Minor Outlying Islands
    </smart-list-item>
    <smart-list-item [value]="'Uruguay'">Uruguay</smart-list-item>
    <smart-list-item [value]="'Uzbekistan'">Uzbekistan</smart-list-item>
    <smart-list-item [value]="'Vanuatu'">Vanuatu</smart-list-item>
    <smart-list-item [value]="'Venezuela'">Venezuela</smart-list-item>
    <smart-list-item [value]="'Viet Nam'">Viet Nam</smart-list-item>
    <smart-list-item [value]="'Virgin Islands, British'">Virgin Islands, British</smart-list-item>
    <smart-list-item [value]="'Virgin Islands, U.S.'">Virgin Islands, U.S.</smart-list-item>
    <smart-list-item [value]="'Wallis and Futuna'">Wallis and Futuna</smart-list-item>
    <smart-list-item [value]="'Western Sahara'">Western Sahara</smart-list-item>
    <smart-list-item [value]="'Yemen'">Yemen</smart-list-item>
    <smart-list-item [value]="'Zambia'">Zambia</smart-list-item>
    <smart-list-item [value]="'Zimbabwe'">Zimbabwe</smart-list-item>
</smart-multi-split-button>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put MultiSplitButtonModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put MultiSplitButtonModule from smart-webcomponents-angular/multisplitbutton on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { MultiSplitButtonModule } from 'smart-webcomponents-angular/multisplitbutton';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, MultiSplitButtonModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Accessibility

The MultiSplitButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React MultiSplitButton Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/multisplitbutton/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { MultiSplitButton, ListItem } from 'smart-webcomponents-react/multisplitbutton';

const App = () => {
    return (
        <div>
            <MultiSplitButton buttonsDataSource={['1', '2', '3']}>
                <ListItem value="Afghanistan">Afghanistan</ListItem>
                <ListItem selected value="Albania">Albania</ListItem>
                <ListItem value="Algeria">Algeria</ListItem>
                <ListItem value="American Samoa">American Samoa</ListItem>
                <ListItem value="Andorra">Andorra</ListItem>
                <ListItem value="Angola">Angola</ListItem>
                <ListItem value="Anguilla">Anguilla</ListItem>
                <ListItem value="Antarctica">Antarctica</ListItem>
                <ListItem value="Antigua and Barbuda">Antigua and Barbuda</ListItem>
                <ListItem value="Argentina">Argentina</ListItem>
                <ListItem value="Armenia">Armenia</ListItem>
                <ListItem value="Aruba">Aruba</ListItem>
                <ListItem value="Australia">Australia</ListItem>
                <ListItem value="Austria">Austria</ListItem>
                <ListItem value="Azerbaijan">Azerbaijan</ListItem>
                <ListItem value="Bahamas">Bahamas</ListItem>
                <ListItem value="Bahrain">Bahrain</ListItem>
                <ListItem value="Bangladesh">Bangladesh</ListItem>
                <ListItem value="Barbados">Barbados</ListItem>
                <ListItem value="Belarus">Belarus</ListItem>
                <ListItem value="Belgium">Belgium</ListItem>
                <ListItem value="Belize">Belize</ListItem>
                <ListItem value="Benin">Benin</ListItem>
                <ListItem value="Bermuda">Bermuda</ListItem>
                <ListItem value="Bhutan">Bhutan</ListItem>
                <ListItem value="Bolivia">Bolivia</ListItem>
                <ListItem value="Bosnia and Herzegovina">Bosnia and Herzegovina</ListItem>
                <ListItem value="Botswana">Botswana</ListItem>
                <ListItem value="Bouvet Island">Bouvet Island</ListItem>
                <ListItem value="Brazil">Brazil</ListItem>
                <ListItem value="British Indian Ocean Territory">British Indian Ocean Territory</ListItem>
                <ListItem value="Brunei Darussalam">Brunei Darussalam</ListItem>
                <ListItem value="Bulgaria">Bulgaria</ListItem>
                <ListItem value="Burkina Faso">Burkina Faso</ListItem>
                <ListItem value="Burundi">Burundi</ListItem>
                <ListItem value="Cambodia">Cambodia</ListItem>
                <ListItem value="Cameroon">Cameroon</ListItem>
                <ListItem value="Canada">Canada</ListItem>
                <ListItem value="Cape Verde">Cape Verde</ListItem>
                <ListItem value="Cayman Islands">Cayman Islands</ListItem>
                <ListItem value="Central African Republic">Central African Republic</ListItem>
                <ListItem value="Chad">Chad</ListItem>
                <ListItem value="Chile">Chile</ListItem>
                <ListItem value="China">China</ListItem>
                <ListItem value="Christmas Island">Christmas Island</ListItem>
                <ListItem value="Cocos (Keeling) Islands">Cocos Islands</ListItem>
                <ListItem value="Colombia">Colombia</ListItem>
                <ListItem value="Comoros">Comoros</ListItem>
                <ListItem value="Congo">Congo</ListItem>
                <ListItem value="Congo, The Democratic Republic of The">Congo</ListItem>
                <ListItem value="Cook Islands">Cook Islands</ListItem>
                <ListItem value="Costa Rica">Costa Rica</ListItem>
                <ListItem value="Cote D'ivoire">Cote D'ivoire</ListItem>
                <ListItem value="Croatia">Croatia</ListItem>
                <ListItem value="Cuba">Cuba</ListItem>
                <ListItem value="Cyprus">Cyprus</ListItem>
                <ListItem value="Czech Republic">Czech Republic</ListItem>
                <ListItem value="Denmark">Denmark</ListItem>
                <ListItem value="Djibouti">Djibouti</ListItem>
                <ListItem value="Dominica">Dominica</ListItem>
                <ListItem value="Dominican Republic">Dominican Republic</ListItem>
                <ListItem value="Ecuador">Ecuador</ListItem>
                <ListItem value="Egypt">Egypt</ListItem>
                <ListItem value="El Salvador">El Salvador</ListItem>
                <ListItem value="Equatorial Guinea">Equatorial Guinea</ListItem>
                <ListItem value="Eritrea">Eritrea</ListItem>
                <ListItem value="Estonia">Estonia</ListItem>
                <ListItem value="Ethiopia">Ethiopia</ListItem>
                <ListItem value="Falkland Islands (Malvinas)">Falkland Islands</ListItem>
                <ListItem value="Faroe Islands">Faroe Islands</ListItem>
                <ListItem value="Fiji">Fiji</ListItem>
                <ListItem value="Finland">Finland</ListItem>
                <ListItem value="France">France</ListItem>
                <ListItem value="French Guiana">French Guiana</ListItem>
                <ListItem value="French Polynesia">French Polynesia</ListItem>
                <ListItem value="French Southern Territories">French Southern Territories</ListItem>
                <ListItem value="Gabon">Gabon</ListItem>
                <ListItem value="Gambia">Gambia</ListItem>
                <ListItem value="Georgia">Georgia</ListItem>
                <ListItem value="Germany">Germany</ListItem>
                <ListItem value="Ghana">Ghana</ListItem>
                <ListItem value="Gibraltar">Gibraltar</ListItem>
                <ListItem value="Greece">Greece</ListItem>
                <ListItem value="Greenland">Greenland</ListItem>
                <ListItem value="Grenada">Grenada</ListItem>
                <ListItem value="Guadeloupe">Guadeloupe</ListItem>
                <ListItem value="Guam">Guam</ListItem>
                <ListItem value="Guatemala">Guatemala</ListItem>
                <ListItem value="Guinea">Guinea</ListItem>
                <ListItem value="Guinea-bissau">Guinea-bissau</ListItem>
                <ListItem value="Guyana">Guyana</ListItem>
                <ListItem value="Haiti">Haiti</ListItem>
                <ListItem value="Heard Island and Mcdonald Islands">Heard Island and Mcdonald Islands</ListItem>
                <ListItem value="Holy See (Vatican City State)">Holy See</ListItem>
                <ListItem value="Honduras">Honduras</ListItem>
                <ListItem value="Hong Kong">Hong Kong</ListItem>
                <ListItem value="Hungary">Hungary</ListItem>
                <ListItem value="Iceland">Iceland</ListItem>
                <ListItem value="India">India</ListItem>
                <ListItem value="Indonesia">Indonesia</ListItem>
                <ListItem value="Iran, Islamic Republic of">Iran</ListItem>
                <ListItem value="Iraq">Iraq</ListItem>
                <ListItem value="Ireland">Ireland</ListItem>
                <ListItem value="Israel">Israel</ListItem>
                <ListItem value="Italy">Italy</ListItem>
                <ListItem value="Jamaica">Jamaica</ListItem>
                <ListItem value="Japan">Japan</ListItem>
                <ListItem value="Jordan">Jordan</ListItem>
                <ListItem value="Kazakhstan">Kazakhstan</ListItem>
                <ListItem value="Kenya">Kenya</ListItem>
                <ListItem value="Kiribati">Kiribati</ListItem>
                <ListItem value="Korea, Democratic People's Republic of">Korea</ListItem>
                <ListItem value="Korea, Republic of">Korea, Republic of</ListItem>
                <ListItem value="Kuwait">Kuwait</ListItem>
                <ListItem value="Kyrgyzstan">Kyrgyzstan</ListItem>
                <ListItem value="Lao People's Democratic Republic">Lao People's Democratic Republic</ListItem>
                <ListItem value="Latvia">Latvia</ListItem>
                <ListItem value="Lebanon">Lebanon</ListItem>
                <ListItem value="Lesotho">Lesotho</ListItem>
                <ListItem value="Liberia">Liberia</ListItem>
                <ListItem value="Libyan Arab Jamahiriya">Libyan Arab Jamahiriya</ListItem>
                <ListItem value="Liechtenstein">Liechtenstein</ListItem>
                <ListItem value="Lithuania">Lithuania</ListItem>
                <ListItem value="Luxembourg">Luxembourg</ListItem>
                <ListItem value="Macao">Macao</ListItem>
                <ListItem value="Macedonia, The Former Yugoslav Republic of">Macedonia</ListItem>
                <ListItem value="Madagascar">Madagascar</ListItem>
                <ListItem value="Malawi">Malawi</ListItem>
                <ListItem value="Malaysia">Malaysia</ListItem>
                <ListItem value="Maldives">Maldives</ListItem>
                <ListItem value="Mali">Mali</ListItem>
                <ListItem value="Malta">Malta</ListItem>
                <ListItem value="Marshall Islands">Marshall Islands</ListItem>
                <ListItem value="Martinique">Martinique</ListItem>
                <ListItem value="Mauritania">Mauritania</ListItem>
                <ListItem value="Mauritius">Mauritius</ListItem>
                <ListItem value="Mayotte">Mayotte</ListItem>
                <ListItem value="Mexico">Mexico</ListItem>
                <ListItem value="Micronesia, Federated States of">Micronesia</ListItem>
                <ListItem value="Moldova, Republic of">Moldova, Republic of</ListItem>
                <ListItem value="Monaco">Monaco</ListItem>
                <ListItem value="Mongolia">Mongolia</ListItem>
                <ListItem value="Montserrat">Montserrat</ListItem>
                <ListItem value="Morocco">Morocco</ListItem>
                <ListItem value="Mozambique">Mozambique</ListItem>
                <ListItem value="Myanmar">Myanmar</ListItem>
                <ListItem value="Namibia">Namibia</ListItem>
                <ListItem value="Nauru">Nauru</ListItem>
                <ListItem value="Nepal">Nepal</ListItem>
                <ListItem value="Netherlands">Netherlands</ListItem>
                <ListItem value="Netherlands Antilles">Netherlands Antilles</ListItem>
                <ListItem value="New Caledonia">New Caledonia</ListItem>
                <ListItem value="New Zealand">New Zealand</ListItem>
                <ListItem value="Nicaragua">Nicaragua</ListItem>
                <ListItem value="Niger">Niger</ListItem>
                <ListItem value="Nigeria">Nigeria</ListItem>
                <ListItem value="Niue">Niue</ListItem>
                <ListItem value="Norfolk Island">Norfolk Island</ListItem>
                <ListItem value="Northern Mariana Islands">Northern Mariana Islands</ListItem>
                <ListItem value="Norway">Norway</ListItem>
                <ListItem value="Oman">Oman</ListItem>
                <ListItem value="Pakistan">Pakistan</ListItem>
                <ListItem value="Palau">Palau</ListItem>
                <ListItem value="Palestinian Territory, Occupied">Palestinian Territory, Occupied</ListItem>
                <ListItem value="Panama">Panama</ListItem>
                <ListItem value="Papua New Guinea">Papua New Guinea</ListItem>
                <ListItem value="Paraguay">Paraguay</ListItem>
                <ListItem value="Peru">Peru</ListItem>
                <ListItem value="Philippines">Philippines</ListItem>
                <ListItem value="Pitcairn">Pitcairn</ListItem>
                <ListItem value="Poland">Poland</ListItem>
                <ListItem value="Portugal">Portugal</ListItem>
                <ListItem value="Puerto Rico">Puerto Rico</ListItem>
                <ListItem value="Qatar">Qatar</ListItem>
                <ListItem value="Reunion">Reunion</ListItem>
                <ListItem value="Romania">Romania</ListItem>
                <ListItem value="Russian Federation">Russian Federation</ListItem>
                <ListItem value="Rwanda">Rwanda</ListItem>
                <ListItem value="Saint Helena">Saint Helena</ListItem>
                <ListItem value="Saint Kitts and Nevis">Saint Kitts and Nevis</ListItem>
                <ListItem value="Saint Lucia">Saint Lucia</ListItem>
                <ListItem value="Saint Pierre and Miquelon">Saint Pierre and Miquelon</ListItem>
                <ListItem value="Saint Vincent and The Grenadines">Saint Vincent and The Grenadines</ListItem>
                <ListItem value="Samoa">Samoa</ListItem>
                <ListItem value="San Marino">San Marino</ListItem>
                <ListItem value="Sao Tome and Principe">Sao Tome and Principe</ListItem>
                <ListItem value="Saudi Arabia">Saudi Arabia</ListItem>
                <ListItem value="Senegal">Senegal</ListItem>
                <ListItem value="Serbia and Montenegro">Serbia and Montenegro</ListItem>
                <ListItem value="Seychelles">Seychelles</ListItem>
                <ListItem value="Sierra Leone">Sierra Leone</ListItem>
                <ListItem value="Singapore">Singapore</ListItem>
                <ListItem value="Slovakia">Slovakia</ListItem>
                <ListItem value="Slovenia">Slovenia</ListItem>
                <ListItem value="Solomon Islands">Solomon Islands</ListItem>
                <ListItem value="Somalia">Somalia</ListItem>
                <ListItem value="South Africa">South Africa</ListItem>
                <ListItem value="South Georgia and The South Sandwich Islands">South Georgia</ListItem>
                <ListItem value="Spain">Spain</ListItem>
                <ListItem value="Sri Lanka">Sri Lanka</ListItem>
                <ListItem value="Sudan">Sudan</ListItem>
                <ListItem value="Suriname">Suriname</ListItem>
                <ListItem value="Svalbard and Jan Mayen">Svalbard and Jan Mayen</ListItem>
                <ListItem value="Swaziland">Swaziland</ListItem>
                <ListItem value="Sweden">Sweden</ListItem>
                <ListItem value="Switzerland">Switzerland</ListItem>
                <ListItem value="Syrian Arab Republic">Syrian Arab Republic</ListItem>
                <ListItem value="Taiwan, Province of China">Taiwan, Province of China</ListItem>
                <ListItem value="Tajikistan">Tajikistan</ListItem>
                <ListItem value="Tanzania, United Republic of">Tanzania, United Republic of</ListItem>
                <ListItem value="Thailand">Thailand</ListItem>
                <ListItem value="Timor-leste">Timor-leste</ListItem>
                <ListItem value="Togo">Togo</ListItem>
                <ListItem value="Tokelau">Tokelau</ListItem>
                <ListItem value="Tonga">Tonga</ListItem>
                <ListItem value="Trinidad and Tobago">Trinidad and Tobago</ListItem>
                <ListItem value="Tunisia">Tunisia</ListItem>
                <ListItem value="Turkey">Turkey</ListItem>
                <ListItem value="Turkmenistan">Turkmenistan</ListItem>
                <ListItem value="Turks and Caicos Islands">Turks and Caicos Islands</ListItem>
                <ListItem value="Tuvalu">Tuvalu</ListItem>
                <ListItem value="Uganda">Uganda</ListItem>
                <ListItem value="Ukraine">Ukraine</ListItem>
                <ListItem value="United Arab Emirates">United Arab Emirates</ListItem>
                <ListItem value="United Kingdom">United Kingdom</ListItem>
                <ListItem value="United States">United States</ListItem>
                <ListItem value="United States Minor Outlying Islands">United States Minor Outlying Islands</ListItem>
                <ListItem value="Uruguay">Uruguay</ListItem>
                <ListItem value="Uzbekistan">Uzbekistan</ListItem>
                <ListItem value="Vanuatu">Vanuatu</ListItem>
                <ListItem value="Venezuela">Venezuela</ListItem>
                <ListItem value="Viet Nam">Viet Nam</ListItem>
                <ListItem value="Virgin Islands, British">Virgin Islands, British</ListItem>
                <ListItem value="Virgin Islands, U.S.">Virgin Islands, U.S.</ListItem>
                <ListItem value="Wallis and Futuna">Wallis and Futuna</ListItem>
                <ListItem value="Western Sahara">Western Sahara</ListItem>
                <ListItem value="Yemen">Yemen</ListItem>
                <ListItem value="Zambia">Zambia</ListItem>
                <ListItem value="Zimbabwe">Zimbabwe</ListItem>
            </MultiSplitButton>
        </div>
    );
}

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { MultiSplitButton, MultiSplitButtonProps } from 'smart-webcomponents-react/multisplitbutton';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The MultiSplitButton component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.